# List

This endpoint lists all currently open offers and can be used in [streaming](/api/introduction/streaming.md) mode.

Streaming mode allows you to listen for new offers as they are added to the Stellar ledger. If called in streaming mode, Horizon will start at the earliest known offer unless a `cursor` is set, in which case it will start from that `cursor`. By setting the cursor value to `now`, you can stream offers created since your request time.

When filtering by buying or selling arguments, you must use a combination of `selling_asset_type`, `selling_asset_issuer`, and `selling_asset_code` for the selling asset, or a combination of `buying_asset_type`, `buying_asset_issuer`, and `buying_asset_code` for the buying asset.

&#x20;\- ARGUMENT -&#x20;

* sponsor `optional`

  The account ID of the sponsor who is paying the reserves for all the offers included in the response.
* seller `optional`

  The account ID of the offer creator.
* selling\_asset\_type `optional`

  The type for the selling asset. Either `native`, `credit_alphanum4`, or `credit_alphanum12`.
* selling\_asset\_issuer `optional`

  The Stellar address of the selling asset’s issuer.
* selling\_asset\_code `optional`

  The code for the selling asset.
* buying\_asset\_type `optional`

  The type for the buying asset. Either `native`, `credit_alphanum4`, or `credit_alphanum12`.
* buying\_asset\_issuer `optional`

  The Stellar address of the buying asset’s issuer.
* buying\_asset\_code `optional`

  The code for the buying asset.
* cursor `optional`

  A number that points to a specific location in a collection of responses and is pulled from the `paging_token` value of a record.
* order `optional`

  A designation of the order in which records should appear. Options include `asc`(ascending) or `desc` (descending). If this argument isn’t set, it defaults to `asc`.
* limit `optional`

  The total number of records returned. The limit can range from 1 to 200 - an upper limit that is hardcoded in Horizon for performance reasons. If this argument isn’t designated, it defaults to 10.

{% tabs %}
{% tab title="JavaScript" %}

```javascript
var StellarSdk = require("stellar-sdk");
var server = new StellarSdk.Server("https://expansion-testnet.bantu.network");

server
  .offers()
  .selling(
    new StellarSdk.Asset(
      "USD",
      "GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX",
    ),
  )
  .call()
  .then(function (resp) {
    console.log(resp);
  })
  .catch(function (err) {
    console.error(err);
  });
```

{% endtab %}

{% tab title="cURL" %}

```bash
curl "https://expansion-testnet.bantu.network/offers?selling_asset_type=credit_alphanum4&selling_asset_issuer=GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX&selling_asset_code=USD&limit=3"
```

{% endtab %}
{% endtabs %}

```bash
{
  "_links": {
    "self": {
      "href": "https://expansion-testnet.bantu.network/offers?cursor=\u0026limit=3\u0026order=asc\u0026selling_asset_code=USD\u0026selling_asset_issuer=GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX\u0026selling_asset_type=credit_alphanum4"
    },
    "next": {
      "href": "https://expansion-testnet.bantu.network/offers?cursor=88345152\u0026limit=3\u0026order=asc\u0026selling_asset_code=USD\u0026selling_asset_issuer=GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX\u0026selling_asset_type=credit_alphanum4"
    },
    "prev": {
      "href": "https://expansion-testnet.bantu.network/offers?cursor=71673427\u0026limit=3\u0026order=desc\u0026selling_asset_code=USD\u0026selling_asset_issuer=GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX\u0026selling_asset_type=credit_alphanum4"
    }
  },
  "_embedded": {
    "records": [
      {
        "_links": {
          "self": {
            "href": "https://expansion-testnet.bantu.network/offers/71673427"
          },
          "offer_maker": {
            "href": "https://expansion-testnet.bantu.network/accounts/GBJPWEIFX6KO4H52BF3QJDYRCLXB2P3Z3QTKWUGFOOFH5MSRZV4WLRZ7"
          }
        },
        "id": 71673427,
        "paging_token": "71673427",
        "seller": "GBJPWEIFX6KO4H52BF3QJDYRCLXB2P3Z3QTKWUGFOOFH5MSRZV4WLRZ7",
        "selling": {
          "asset_type": "credit_alphanum4",
          "asset_code": "USD",
          "asset_issuer": "GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX"
        },
        "buying": {
          "asset_type": "credit_alphanum4",
          "asset_code": "BTC",
          "asset_issuer": "GAUTUYY2THLF7SGITDFMXJVYH3LHDSMGEAKSBU267M2K7A3W543CKUEF"
        },
        "amount": "25.6545775",
        "price_r": {
          "n": 289696073,
          "d": 25654776
        },
        "price": "11.2920913",
        "last_modified_ledger": 26981646,
        "last_modified_time": "2019-11-26T13:42:10Z"
      },
      {
        "_links": {
          "self": {
            "href": "https://expansion-testnet.bantu.network/offers/88328208"
          },
          "offer_maker": {
            "href": "https://expansion-testnet.bantu.network/accounts/GBSYMLHG5TGQ4O3NSPIO4DSCS4AC6YRJOQWQC3EW7O257RAUHI5SA45R"
          }
        },
        "id": 88328208,
        "paging_token": "88328208",
        "seller": "GBSYMLHG5TGQ4O3NSPIO4DSCS4AC6YRJOQWQC3EW7O257RAUHI5SA45R",
        "selling": {
          "asset_type": "credit_alphanum4",
          "asset_code": "USD",
          "asset_issuer": "GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX"
        },
        "buying": {
          "asset_type": "credit_alphanum4",
          "asset_code": "BTC",
          "asset_issuer": "GBVOL67TMUQBGL4TZYNMY3ZQ5WGQYFPFD5VJRWXR72VA33VFNL225PL5"
        },
        "amount": "2.4664893",
        "price_r": {
          "n": 500,
          "d": 1233
        },
        "price": "0.4055150",
        "last_modified_ledger": 23886660,
        "last_modified_time": "2019-05-17T00:33:16Z"
      },
      {
        "_links": {
          "self": {
            "href": "https://expansion-testnet.bantu.network/offers/88345152"
          },
          "offer_maker": {
            "href": "https://expansion-testnet.bantu.network/accounts/GACTQP5TAWIXF2LV4GWGJWIUNHKDWZ2ITCFDP37FIGOFPR3ORMQRR63U"
          }
        },
        "id": 88345152,
        "paging_token": "88345152",
        "seller": "GACTQP5TAWIXF2LV4GWGJWIUNHKDWZ2ITCFDP37FIGOFPR3ORMQRR63U",
        "selling": {
          "asset_type": "credit_alphanum4",
          "asset_code": "USD",
          "asset_issuer": "GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX"
        },
        "buying": {
          "asset_type": "credit_alphanum4",
          "asset_code": "USD",
          "asset_issuer": "GBUYUAI75XXWDZEKLY66CFYKQPET5JR4EENXZBUZ3YXZ7DS56Z4OKOFU"
        },
        "amount": "10.0000000",
        "price_r": {
          "n": 11,
          "d": 10
        },
        "price": "1.1000000",
        "last_modified_ledger": 23887778,
        "last_modified_time": "2019-05-17T02:19:19Z"
      }
    ]
  }
}
```

```javascript
var StellarSdk = require("stellar-sdk");
var server = new StellarSdk.Server("https://expansion-testnet.bantu.network");

var callback = function (resp) {
  console.log(resp);
};

var es = server
  .offers()
  .selling(
    new StellarSdk.Asset(
      "USD",
      "GDUKMGUGDZQK6YHYA5Z6AY2G4XDSZPSZ3SW5UN3ARVMO6QSRDWP5YLEX",
    ),
  )
  .cursor("now")
  .stream({ onmessage: callback });
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.docs.bantufoundation.org/api/resources/offers/list.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
